<?php

class wcnn_setting {

	function __construct() {

		add_action( 'admin_menu', array( $this, 'add_pages' ) );
	}

	function add_pages() {

		add_menu_page(
			'WP Custom Noindex Nofollow',
			'Noindex Nofollow',
			'level_8',
			__FILE__,
			array( $this, 'wcnn_option_page' ),
			''
		);

	}

	function wcnn_option_page() {

		$update = false;
		$delete = false;

		if ( ! empty( $_POST ) ) {

			if ( ! isset( $_POST['wcnn_nonce'] ) ||
			     ! wp_verify_nonce( $_POST['wcnn_nonce'], wp_create_nonce( __FILE__ ) ) ) {
				return;
			}

			if ( isset( $_POST['wcnn'] ) ) {

				$update_opt = array();

				foreach ( array_keys( $_POST['wcnn'] ) as $key ) {

					if ( isset( $_POST['wcnn'][$key] ) ) {

						$update_opt[$key] = true;

					} 
				}

				update_option( 'wcnn_options', $update_opt );
				$update = true;

			} else if ( isset( $_POST['wcnn_del']['delete_post'] ) ) {

				if ( count( wcnn_get_all_post() ) ) {

					delete_post_meta_by_key( 'wcnn' );

				}

				$delete = true;

			} else if ( isset( $_POST['wcnn_del']['delete_term'] ) ) {

				$wcnn_all_terms = wcnn_get_all_term();

				if ( count( $wcnn_all_terms ) ) {

					foreach ( $wcnn_all_terms as $term_id ) {

						delete_term_meta( $term_id, 'wcnn' );

					}

				}

				$delete = true;

			} else if ( isset( $_POST['wcnn_del']['delete_global'] ) ) {

				delete_option( 'wcnn_options' );
				$delete = true;

			}

		}

		$opt = get_option( 'wcnn_options' );

		if ( $update ) {

			echo "<div class=\"updated fade\"><p><b>設定を保存しました。</b></p></div>\n";

		} else if ( $delete ) {

			echo "<div class=\"updated fade\"><p><b>設定を削除しました。</b></p></div>\n";

		}

		?>

<div class="wrap">
<h2>WP Custom Noindex Nofollow</h2>
<div class="metabox-holder">

<!-- left start -->
<div class="postbox-container" style="width:50%;margin-right:10px;">
<div class="postbox">
<h3 class="hndle ui-sortable-handle">noindex化するページ</h3>
<form id="wcnn-form" action="" method="post">
<div class="inside">
<table class="form-table">

<?php /* pages */

	$post_types = get_post_types( array( 'public' => true ), 'objects' );

	foreach ( $post_types as $post_type ) {

		if ( $post_type->name == 'attachment' ) {
			continue;
		}

?>

<tr valign="top">
	<th scope="row">
		<label for="inputtext"><?php echo $post_type->label; ?></label>
	</th>
	<td>
		<label><input type="checkbox" name="wcnn[noindex_<?php echo $post_type->name; ?>]" value="1" <?php if ( isset( $opt['noindex_' . $post_type->name] ) && $opt['noindex_' . $post_type->name] ) { echo 'checked'; } ?>> 有効化</label>
		<p class="description">有効化すると個別設定は無視されます。</p>
	</td>
</tr>

<?php
	}
?>

<tr valign="top">
	<th scope="row">
		<label for="inputtext">カテゴリー</label>
	</th>
	<td>
		<label><input type="checkbox" name="wcnn[noindex_category]" value="1" <?php if ( isset( $opt['noindex_category'] ) && $opt['noindex_category'] ) { echo 'checked'; } ?>> 有効化</label>
		<p class="description">有効化すると個別設定は無視されます。</p>
	</td>
</tr>

<tr valign="top">
	<th scope="row">
		<label for="inputtext">タグ</label>
	</th>
	<td>
		<label><input type="checkbox" name="wcnn[noindex_post_tag]" value="1" <?php if ( isset( $opt['noindex_post_tag'] ) && $opt['noindex_post_tag'] ) { echo 'checked'; } ?>> 有効化</label>
		<p class="description">有効化すると個別設定は無視されます。</p>
	</td>
</tr>

<?php /* custom taxonomies */
	if ( $taxonomies = get_taxonomies( array( 'public' => true, '_builtin' => false ) ) ) {

		foreach ( $taxonomies  as $taxonomy ) {

			$taxonomy = get_taxonomy( $taxonomy );
?>

<tr valign="top">
	<th scope="row">
		<label for="inputtext"><?php echo $taxonomy->label; ?></label>
	</th>
	<td>
		<label><input type="checkbox" name="wcnn[noindex_<?php echo $taxonomy->name; ?>]" value="1" <?php if ( isset( $opt['noindex_' . $taxonomy->name] ) && $opt['noindex_' . $taxonomy->name] ) { echo 'checked'; } ?>> 有効化</label>
		<p class="description">有効化すると個別設定は無視されます。</p>
	</td>
</tr>

<?php
		}
	}
?>

<tr valign="top">
	<th scope="row">
		<label for="inputtext">日付アーカイブ (年/月/日)</label>
	</th>
	<td>
		<label><input type="checkbox" name="wcnn[noindex_date]" value="1" <?php if ( isset( $opt['noindex_date'] ) && $opt['noindex_date'] ) { echo 'checked'; } ?>> 有効化</label>
	</td>
</tr>

<tr valign="top">
	<th scope="row">
		<label for="inputtext">投稿者アーカイブ</label>
	</th>
	<td>
		<label><input type="checkbox" name="wcnn[noindex_author]" value="1" <?php if ( isset( $opt['noindex_author'] ) && $opt['noindex_author'] ) { echo 'checked'; } ?>> 有効化</label>
	</td>
</tr>

<tr valign="top">
	<th scope="row">
		<label for="inputtext">検索結果</label>
	</th>
	<td>
		<label><input type="checkbox" name="wcnn[noindex_search]" value="1" <?php if ( isset( $opt['noindex_search'] ) && $opt['noindex_search'] ) { echo 'checked'; } ?>> 有効化</label>
	</td>
</tr>

<tr valign="top">
	<th scope="row">
		<label for="inputtext">2ページ目以降</label>
	</th>
	<td>
		<label><input type="checkbox" name="wcnn[noindex_paged]" value="1" <?php if ( isset( $opt['noindex_paged'] ) && $opt['noindex_paged'] ) { echo 'checked'; } ?>> 有効化</label>
	</td>
</tr>

<tr valign="top">
	<th scope="row">
		<label for="inputtext">404ページ</label>
	</th>
	<td>
		<label><input type="checkbox" name="wcnn[noindex_404]" value="1" <?php if ( isset( $opt['noindex_404'] ) && $opt['noindex_404'] ) { echo 'checked'; } ?>> 有効化</label>
	</td>
</tr>

</table>

<?php wp_nonce_field( wp_create_nonce( __FILE__ ), 'wcnn_nonce' ); ?>

</div><!-- .inside -->

<div id="major-publishing-actions">
<div id="publishing-action">
<input type="submit" name="submit" class="button-primary" value="設定" />
</div><!-- #publishing-action -->
<div class="clear"></div>
</div><!-- #major-publishing-actions -->

</form>
</div><!-- .postbox -->
</div><!-- .postbox-container -->
<!-- left end -->

<!-- right start -->
<div class="postbox-container" style="width:47%;">
<div class="postbox">
<h3 class="hndle ui-sortable-handle">設定削除</h3>
<form id="wcnn-del-form" action="" method="post">
<div class="inside">
<p class="description">※アンインストールする時は全て削除してから停止してください。</p>
<table class="form-table">

<tr valign="top">
	<th scope="row">
		<label for="inputtext">投稿・固定ページ</label>
	</th>
	<td>
		<label><input type="checkbox" name="wcnn_del[delete_post]" value="1"> 全削除</label>
		<?php $wcnn_all_posts = count( wcnn_get_all_post() ); ?>
		<?php if ( $wcnn_all_posts ) : ?>
		<p class="description"><?php echo $wcnn_all_posts; ?>件の個別設定を削除。</p>
		<?php else : ?>
		<p class="description">現在、個別設定はされていません。</p>
		<?php endif; ?>
	</td>
</tr>

<tr valign="top">
	<th scope="row">
		<label for="inputtext">タクソノミー</label>
	</th>
	<td>
		<label><input type="checkbox" name="wcnn_del[delete_term]" value="1"> 全削除</label>
		<?php $wcnn_all_terms = count( wcnn_get_all_term() ); ?>
		<?php if ( $wcnn_all_terms ) : ?>
		<p class="description"><?php echo $wcnn_all_terms; ?>件の個別設定を削除。</p>
		<?php else : ?>
		<p class="description">現在、個別設定はされていません。</p>
		<?php endif; ?>
	</td>
</tr>

<tr valign="top">
	<th scope="row">
		<label for="inputtext">全体設定</label>
	</th>
	<td>
		<label><input type="checkbox" name="wcnn_del[delete_global]" value="1"> 削除</label>
		<p class="description">左メニューの全項目を無効化します。</p>
	</td>
</tr>

</table>

<?php wp_nonce_field( wp_create_nonce( __FILE__ ), 'wcnn_nonce' ); ?>

</div><!-- .inside -->

<div id="major-publishing-actions">
<div id="publishing-action">
<input type="submit" name="submit" class="button-primary" value="削除" />
</div><!-- #publishing-action -->
<div class="clear"></div>
</div><!-- #major-publishing-actions -->

</form>
</div><!-- .postbox -->
</div><!-- .postbox-container -->
<!-- right end -->

</div><!-- .metabox-holder -->
</div><!-- .wrap -->

	<?php
	}
}
?>
